PS(1)

NAMN
ps — rapportera en ögonblicksbild av de nuvarande processerna.

SYNOPSIS
ps [flaggor]

BESKRIVNING
ps visar information om ett urval av de aktiva processerna. Om du vill ha en upprepad uppdatering av urvalet och den visade informationen, använd top istället.

Denna version av ps accepterar flera olika sorters flaggor:

1   UNIX-flaggor, som kan grupperas och måste föregås av ett bindestreck.
2   BSD-flaggor, som kan grupperas och inte får föregås av ett bindestreck.
3   GNU långa flaggor, vilka föregås av två bindestreck.

Flaggor av olika typer får blandas fritt, men konflikter kan förekomma. Det finns några synonyma flaggor, vars funktionalitet är identisk, på grund av de många standarder och ps-implementationer som denna ps är kompatibel med.

Observera att ps -aux är skilt från ps aux. POSIX- och UNIX-standarderna kräver att ps -aux skriver ut alla processer som ägs av en användare med namnet x, såväl som att den skriver ut alla processer som skulle ha valts med flaggan -a. Om användaren med namnet x inte finns kan denna ps tolka kommandot som ps aux istället och skriva en varning. Detta beteende är avsett att hjälpa till i övergången från gamla skript och vanor. Det är bräckligt, kan komma och ändras, och alltså inget man bör lita på.

Som standard väljer ps alla processer med samma effektiva användar-ID (euid=EUID) som den aktiva användaren och associerade med samma terminal som anroparen. Den visar process-ID (pid=PID), terminalen som är associerad med processen (tname=TTY), den ackumulerade CPU-tiden i formatet [DD-]hh:mm:ss (time=TIME) och det körbara namnet (ucmd=CMD). Utdata är osorterat som standard.

Användningen av flaggor i BSD-stil kommer lägga till porcesstatus (stat=STAT) till standardutmatningen och visa kommandoargumenten (args=KOMMANDO) istället för den körbaras namn. Man kan åsidsätta detta med miljövariabeln PS_FORMAT. Användningen av flaggor i BSD-stil kommer även ändra processvalet till att inkludera processer på andra terminaler (TTY:er) som ägs av dig; alternativt kan detta beskrivas som att ställa in valet till att vara mängden av alla processer filtrerad till att utesluta processer som ägs av andr användare eller inte av en termina. Dessa effekter betraktas inte när flaggor beskrivs som att vara ”identiska” nedan, så -M kommer anses identiskt med Z och så vidare.

Förutom som det beskrivs nedan är processvalsflaggor additativa. Standardurvalet kastas och sedan lägs de valda processerna till till mängden processer som skall visas. En process kommer alltså visas om den uppfyller något av de angivna urvalskriterierna.

EXEMPEL

För att se alla processer på systemet använd standardsyntaxen:
    ps -e
    ps -ef
    ps -eF
    ps -ely

För att se alla processer på systemed med BSD-syntax:
    ps ax
    ps axu

För att skriva ut ett processträd:
    ps -ejH
    ps axjf

För att fi information om trådar:
    ps -eLf
    ps axms

För att få säkerhetsinformation:
    ps -eo euser,ruser,suser,fuser,f,comm,label
    ps axZ
    ps -eM

För att se alla processer som kör som root (verkligt & effektivt ID) i användarformat:
    ps -U root -u root u

För att se alla processer med ett användardefinierat format:
    ps -eo pid,tid,class,rtprio,ni,pri,psr,pcpu,stat,wchan:14,comm
    ps axo stat,euid,ruid,tty,tpgid,sess,pgrp,ppid,pid,pcpu,comm
    ps -Ao pid,tt,user,fname,tmout,f,wchan

Skriv endast ut process-ID:n för syslogd:
    ps -C syslogd -o pid=

Skriv endast namnet på PID 42:
    ps -q 42 -o comm=

ENKLA VAL AV PROCESS

a   Lyft begränsningen ”endast dig själv” med BSD-stil, vilken läggs på mängden av alla processer när några flaggor i BSD-stil (utan ”-”) används eller när personlighetsinställningen för ps är BSD-lik. Mängden processer som väljs på detta sätt är utöver mängden processer som väljs på andra sätt. Ett annat sätt att beskriva detta är att denna flagga får ps att lista alla processer med en terminal (tty) eller att lista alla processer när de används tillsammans med flaggan x.

-A  Välj alla processer. Identiskt med -e.

-a  Välj alla processer utom både sessionsledare (se getsid(2)) och processer som inte är associerade med någon terminal.

-d  Välj alla processer utom sessionsledare.

--deselect
    Välj alla processer utom de som möter de angivna villkoren (negerar valet). Identiskt med -N.

-e  Välj alla processer. Identiskt med -A.

g   Verkligen alla, även sessionsledare. Denna flagga är föråldrar och kan försvinna i en framtida utgåva. Den impliceras normalt av flaggan a och är endast användbar på operativsystem i personligheten sunos4.

-N  Välj alla processer utom de som möter de angivna villkoren (negerar valet). Identiskt med --deselect.

T   Välj alla processer associerade med denna terminal. Identiskt med flaggan t utan något argument.

r   Begränsa urvalet till endast körande processer.

x   Lyft begränsningen ”måste ha en ttty” med BSD-stil, vilken läggs på mängden av alla processer när några flaggor i BSD-stil (utan ”-”) används eller när personlighetsinställningen för ps är BSD-lik. Mängden processer som väljs på detta sätt är utöver mängden processer som väljs på andra sätt. Ett annat sätt att beskriva detta är att denna flagga får ps att lista alla processer som ägs av dig (samma EAID som ps) eller att lista alla processer när de används tillsammans med flaggan a.

VAL AV PROCESS MED LISTA
Dessa flaggor tar ett ensamt argument på formen av en mellanslagsseparerad eller kommaseparerad lista. De kan användas flera gånger. Till exempel: ps -p "1 2" -p 3,4

-123
    Identiskt med --pid 123.

123 Identiskt med --pid 123.

-C kmdlista
    Välj via kommandonamn. Detta väljer processerna vars körbara namn är givet i kmdlista. OBS: kommandonamnet är inte samma som kommandoraden. Tidigare verisoner av procps och kärnan högg av detta kommandonamn till 15 tecken. Denna begränsning är inte längre kvar i båda. Om du var beroende av att matcha endast 15 tecken kanske du inte längre får en matchning.

-G grplista
    Välj via verkligt grupp-ID (VGID) eller -namn. Detta väljer processer vars verkliga gruppnamn eller -ID finns i listan grplista. Det verkliga grupp-ID:t identifierar gruppen för användare som skapade processen, se getgid(2).

-g grplista
    Välj via sessions- ELLER effektivt gruppnamn. Val via session anges av många standarder, men val enligt effektiv grupp är det logiska beteendet som flera andra operativsystem använder. Denna ps kommer välja via session när listan är helt numerisk (som sessioner är). Grupp-ID-nummer kommer fungera endast när några gruppnamn också anges. Se flaggorna -s och --group.

--Group grplista
    Välj via verkligt grupp-ID (VGID) eller namn. Identistk med -G.

--group grplista
    Välj via effektivt grupp-ID (EGID) eller namn. Detta väljer processer vars effektiva gruppnamn eller -ID fins i grplista. Det effektiva grupp-ID:t beskriver gruppen var vars filåtkomsträttigheter används av processen (se getegid(2)). Flaggan -g är ofta ett alternativ till --group.

p pidlista
    Väljer via process-ID. Identiskt med -p och --pid.

-p pidlista
    Välj via PID. Detta väljer processer vars process-ID-nummer förekommer i pidlista. Identiskt med p och --pid.

--pid pidlista
    Välj via process-ID. Identiskt med -p och p.

--ppid pidlista
    Välj via föräldraprocess-ID. Detta väljer processerna med en förälderprocess-ID i pidlista. Det vill säga, den väljer processer som är barn av dessa uppräknade i pidlista.

q pidlista
    Välj via process-ID (snabbläge). Identiskt med -q och --quick-pid.

-q pidlista
    Välj via PID (snabbläge). Detta väljer processerna vars process-ID-tal förekommer i pidlista. Med denna flagga läser ps den nödvändiga informationen endast pid:erna som listas i pidlist och tillämpar inte ytterligare filtreringsregler. Ordningen av pid:ar är osorterad och bevarad. Inga ytterligare urvalsflaggor, sorterings- eller skogstypslistningar tillåts i detta läge. Identiskt med q och --quick-pid.

--quick-pid pidlista
    Välj via process-ID (snabbläge). Identiskt med -q och q.

-s sesslista
    Välj via sessions-ID. Detta väljer processerna med en sessions-ID angiven i sesslista.

--sid sesslista
    Välj via sessions-ID. Identiskt med -s.

t ttylista
    Välj via tty. Nästan identiskt med -t och --tty, men kan även användas med en tom ttylista för att indikera att terminalen associerad med ps. Att använda flagga T anses renare än att använda t med en tom ttylista.

-t ttylista
    Välj via tty. Detta väljer processerna associerade med terminalerna angivna i ttylista. Terminaler (tty:er, eller skärmar för textutmatning) kan ages på i flera format: /dev/ttyS1, ttyS1, S1. Ett enkelt ”-” kan användas för att välja processer som ine är kopplade till någon terminal.

--tty ttylista
    Välj via terminal. Identiskt med -t och t.

U användarlista
    Välj via effektiv användar-ID (EAID) eller -namn. Detta väljer processerna vars effektiva användarnamn eller -ID finns i användarlista. Det effektiva användar-ID:t beskriver användaren var vars filåtkomsträttigheter används av processen (se geteuid(2)). Identiskt med -u och --user.

-U användarlista
    Välj via verkligt användar-ID (VAID) eller -namn. Detta väljer processerna vars verkliga användarnamn eller -ID finns i listan användarlista. Det verkliga användar-ID:t identifierar användaren som skapade processen, se getuid(2).

-u användarlista
    Välj via effektivt användar-ID (EAID) eller -namn. Detta väljer processerna vars effektiva användramn eller -ID finns i användarlista.
     Det effektiva användar-ID:t beskriver användaren var vars filåtkomsträttigheter används av processen (se geteuid(2)). Identiskt med U och --user.

--User användarlista
    Välj via verkligt användar-ID (VAID) eller -namn. Identiskt med -U.

--user användarlista
    Välj via effektivt användar-ID (EAID) eller -namn. Identiskt med -u och U.

STYRNING AV UTMATNINGSFORMAT
Dessa flaggor används för att välja informationen som visas av ps. Utmatningen kan skilja beroende på personlighet.

-c  Visa annan schemaläggarinformation för flaggan -l.

--context
    Visa säkerhetskontextsformat (för SELinux).

-f  Gör en helformatslistning. Denna flagga kan kombineras med många andra flaggor i UNIX-stil för att lägga till ytterligare kolumner. Det gör också att kommandoargumenten skrivs ut. När det används med -L kommer kolumnerna NLWP (antal trådar) och LWP (tråd-ID) läggas till. Se flaggan c, formatnyckelordet args och formatnyckelordet comm.

-F  Extra fullt format. Se flaggan -f som -F implicerar.

--format format
    användardefinierat format. Identiskt med -o och o.

j   BSD jobbstyrningsformat.

-j  Jobbformat.

l   Visa BSD:s långa format.

-l  Långt format. Flaggan -y är ofta användbar med denna.

-M  Lägg till en kolumn med säkerhetsdata. Identiskt med Z (för SELinux).

O format
    är förladdad o (överlagrad). BSD-flaggan O kan fungera som -O (användardefinierat utdataformat med några vanliga fält fördefinierade) eller kan användas för att ange sorteringsordning. Heuristiker används för att avgöra beteendet för denna flagga. För att säkerställa att det önskade beteendet erhålls (sortering eller formatering), ange flaggan på något annat sätt (t.ex. med -O eller --sort). När använd som en formateringsflagga är den identisk med -O med BSD-personligheten.

-O format
    Som -o men förladdad med några standardkolumner. Identiskt med -o pid,format,state,tname,time,command eller -o pid,format,tname,time,cmd, se -o nedan.

o format
    Ange användardefinierat format. Identiskt med -o och --format.

-o format
    Användardefinierat format. format är ett enda argument i form av en blankseparerad eller kommaseparerad lista, vilket ger ett sett att ange individuella utdatakolumner. De kända nyckelorden beskrivs i avsnittet STANDARDFORMATSPECIFICERARE nedan. Namn på huvuden kan ändras (ps -o pid,ruser=VerkligAnvändare -o comm=Kommando) som önskas. Om alla kolumnhuvuden är tomma (ps -o pid= -o comm=) kommer huvudraden inte att skrivas ut. Kolumnbredder kommer öka efter behov för breda huvuden; detta kan användas för att bredda kolumner såsom WCHAN (ps -o pid,wchan=BRED-WCHAN-KOLUMN -o comm). Explicit breddstyrning (ps opid,wchan:42,cmd) finns också.. Beteendet hos ps -o pid=X,comm=Y varierar med personligheten; utmatningen kan vara en kolumn med namnen ”X,comm=Y” eller två kolumner med namen ”X” och ”Y”. Använd flera -o-flaggor vid tveksamhet. Använd miljövariabeln PS_FORMAT för att ange en standard som önskas; DefSysV och DefBSD är makron som kan användas för att som välja UNIX- eller BSD-standardkolumner.

-P  Lägg till en kolumn som visar psr.

s   Visa signalformat.

u   Visa användarorienterat format.

v   Visa format för virtuellt minne.

X   Registerformat.

-y  Visa inte flaggor; visa rss istället för addr. Denna flagga kan endast användas med -l.

Z   Lägg till en kolumn med säkerhetsdata. Identiskt med -M (för SELinux).

UTMATNINGSMODIFIERARE

c   Visa det sanna kommandonamnet. Detta härleds från namnet på den körbara filen, istället från argv-värdet. Kommandoargument och eventuella ändringar av dem visas alltså inte. Denna flagga gör i praktiken om formatnyckelordet args till formatnyckelordet comm; den är användbar med formatflagga -f och med de olika formatflaggorna i BSD-stil, vilka alla normalt visar kommandoargumenten. Se flagga -f, formatnyckelordet args och formatnyckelordet comm.

--cols n
    Ange skärmbredd.

--columns n
    Ange skärmbredd.

--cumulative
    Inkludera några data om döda processer (som en summa med föräldern).

-D format
    Ange datumformatet för fältet lstart till format. Detta format tolkas av strftime(3) och skall vara maximalt 24 tecken för att feljustera kolumner.

--date-format format
    Identiskt med -D.

e   Visa miljön efter kommandot.

f   Processhierarki med ASCII-konst (skog).

--forest
    Processträd i ASCII-konst.

h   Inget huvud. (eller, ett huvud per skärm i BSD-personligheten). Flaggan h är problematisk. Standard BSD-ps använder denna flagga för att skriva ett huvud på varje seida av utmatning, men äldre Linux-ps använder denna flagga för att fullständigt avaktivera huvuden. Denna version av ps följer Linux användning att inte skriva huvudet såvida inte BSD-personligheten har valts, i vilket fall den skriver ett huvud på varje sida av utmatning. Oavsett av den aktuella personlighete kan du använda de långa flaggorna --headers och --no-headers för att aktivera utskrift av huvuden på varje sida respektive att avaktivera huvuden fullständigt.

-H  Vissa processhierarki (skog).

--headers
    Repetera huvudrader, en gång per sida med utmatning.

k spec
    Ange sorteringsordning. Sorteringssyntaxen är [+|-]nyckel[,[+|-]nyckel[,…]]. Välj en flerbokstavsnyckel från avsnittet STANDARDFORMATSPECIFICERARE. ”+”:et är frivilligt eftersom standardriktningen är ökande numerisk eller lexikografisk ordning. Identiskt med --sort.

        Exempel:
        ps jaxkuid,-ppid,+pid
        ps axk comm o comm,args
        ps kstart_time -ef

--lines n
    Ange skärmhöjd.

n   Numerisk utmatning för WCHAN och USER (inklusive alla typer av UID och GID).

--no-headers
    Skriv inte ut något huvud alls. --no-heading är ett alias för denna flagga.

O ordning
    Sorteringsordning (överlagrad). BSD-flaggan O kan fungera som -O (användardefinierat utmatningsformat med några vanliga fält fördefinierade) eller kan användas för att ange sorteringsordningen. Heuristiker används för att bestämma beteenendet hos denna flagga. För att vara säker på att det önskade beteendet erhålls (sortering eller formatering), ange flaggan på något annat sätt (t.ex. med -O eller --sort).

    För sortering är syntaxen för det föråldrade syntaxen O från BSD O[+|-]n1[,[+|-]n2[,…]], Det ordnar processlistan enligt den sortering i flera nivåer som specifiseras av sekvensen av enbokstavs korta nycklar n1, n2, … som beskrivs i avsnittet FÖRÅLDRADE SORTERINGSNYCKLAR nedan. ”+”:et är för närvarande frivilligt, det upprepar bara standarrikningen för en nyckel, men kan hjälpa till att särskilja en O-sortering från ett O-format. ”-”:et vänder riktingen endast för den nyckel det föregår.

--rows n
    Ange skärmhöjd.

S   Summera en del information, såsom CPU-användning, från döda barnprocesser till deras förälder. Detta är användbart för att undersöka ett system där en föräldraprocess upprepat grenar av kortlivade barn för att göra arbetet.

--sort spec
    Ange sorteringsordning. Sorteringssyntaxen är [+|-]nyckel[,[+|-]nyckel[,…]]. Välj en flerbokstavsnyckel från avsnittet STANDARDFORMATSPECIFICERARE. ”+”:et är frivilligt eftersom standardordningen är ökande numeriks eller lexikografisk ordning. Identiskt med k. Till exempel: ps jax --sort=uid,-ppid,+pid

w   Bred utmatning. Använd denna flagga två gånger för obegränsad bredd.

-w  Bred utmatning. Använd denna flagga två gånger för obegränsad bredd.

--width n
    Ange skärmbredd.

TRÅDVISNING

H   Visa trådar som om de vore processer.

-L  Visa trådar, möjligen med LWP- och NLWP-kolumner.

m   Visa trådar efter processer.

-m  Visa trådar efter processer.

-T  Visa trådar, möjligen med en SPID-kolumn.

ANNAN INFORMATION

--help avsnitt
    Skriv ut ett hjälpmeddelande. Argumentet avsnitt kan var ett av enkel, lista, utdata, trådar, diverse eller allt. Argumentet kan förkortas till en av de understrukna tecknen som i: e|l|u|t|d|a.

--info
    Skriv ut felsökningsinformation.

L   Lista alla formatspeicicerare.

V   Skriv ut procps-ng-versionen.

-V  Skriv ut procps-ng-versionen.

--version
    Skriv ut procps-ng-versionen.

OBSERVERA
Denna ps fungerar genom att läsa de virtuella filerna i /proc. Denna ps beöver inte vara setuid kmem eller ha några privilegier för att köra. Ge inte denna ps några särskilda rättigheter.

CPU-användning uttrycks för närvarande som en procentandel av tiden som tillbringats körande under hela livstiden för en process. Detta är inte idealiskt och det följer inte standarderna som ps i övrigt följer. Det är osannolikt att summan av CPU-användningen blir precis 100 %.

Fälten SIZE och RSS räknar inte med några delar av en process inklusive sidtabeller, kärnstack, posten thread_info och posten task_struct. Detta är vanligen åtminstone 20 KiB minne som alltid är resident. SIZE är den virtuella storleken på processen (kod+data+stack).

Processer makerade <defunkt> är döda processer (så kallade ”zombier”) som finns kvar för att deras förälder inte har förstört dem ordentligt. Dessa processer kommer att förstöras av init(8) om föräldraprocessen avslutar.

Om längden på användarnamnet är större än bredden på visningskolumnen huggs användarnamnet av. Se formateringsflaggorna -o och -O för att anpassa längden.

Kommandoflaggor såsom ps -aux rekommenderas inte eftersom det är en sammanblandning av två olika standarder. Enligt standarderna POSIX och UNIX begär ovanståend kommando att visa alla processer med en TTY (i allmänhet kommandona användare kör) plus alla processer som ägs av en användare med namnet x. Om den användaren inte finns kommer ps anta att du egentligen menade ps aux.

PROCESSFLAGGOR
Summan av dessa flaggor visas i kolumnen ”F”, som ges av utmatningsspecificeraren flags:

    1   grenad men gjorde inte exec
    4   använde superanvändarprivileger

PROCESSTATUSKODER
Här är de olika värdena som utmatningsspecificerarna s, stat och state (rubrikerna ”STAT” eller ”S”) kommer visa för att beskriva tillståndet hos en process:

    D   oavbrytbar sömn (vanligen IO)
    I   Inaktiv kärntråd
    R   körande eller körbar (på körkön)
    S   avbrytbar sömn (väntar på att en händelse skall avsluta)
    T   stoppad av jobbstyrningssignal
    t   stoppad av en felsökare under spårning
    W   sidväxling (inte giltig sedan kärnan 2.6.xx)
    X   död (skall aldrig synas)
    Z   upphörd process (”zombie”), avslutad men inte skördad av sin förälder

För BSD-format och när nyckelordet stat används kan ytterligare bokstäver visas:

    <   hög prioritet (inte trevlig mot andra användare)
    N   låg prioritet (trevlig mot andra användare)
    L   har sidor låsta i minnet (för realtid och anpassat IO)
    s   är en sessionsledare
    l   är multitrådad (använder CLONE_THREAD, som NPTL pthreads gör)
    +   är i förgrundsprocessgruppen

FÖRÅLDRADE SORTERINGSNYCKLAR
Dessa nycklar används av BSD-flaggan O (när den används för sortering). GNU-flaggan --sort använder inte dessa nycklar, utan specificerarna som beskrivs i avsnittet STANDARDFORMATSPECIFICERARE. Observera att värdena som används i sorteringen är de interna värden som ps använder och inte de ”kokta” värden som används i några av utmatningsformatsfälten (t.ex. kommer sortering på tty sortera efter enhetsnummer, inte enligt terminalnamnet som visas). Skicka utdata från ps i rör till kommandot sort(1) om du vill sortera de kokta värdena.
NYCKEL | LÅNG | BESKRIVNING
c | cmd | enkelt namn på den körbara
C | pcpu | cpu-användning
f | flags | flaggor som i det långa formatets F-fält
g | pgrp | processgrupp-ID
G | tpgid | styrande tty-processgrupps-ID
j | cutime | kumulativ användartid
J | cstime | kumulativ systemtid
k | utime | användartid
m | min_flt | antal mindre sidfel
M | maj_flt | antal större sidfel
n | cmin_flt | kumulativt mindre sidfel
N | cmaj_flt | kumulativt större sidfel
o | session | sessions-ID
p | pid | process-ID
P | ppid | föräldraprocess-ID
r | rss | residenta mängdens storlek
R | resident | residenta sidor
s | size | minnesstorlek i kilobyte
S | share | mängden delade sidor
t | tty | enhetsnumret på den styrande tty:n
T | start_time | tidpunkten processen startades
U | uid | användarens ID-nummer
u | user | användarnamn
v | vsize | total VM-storlek i KiB
y | priority | kärnskemaläggningsprioritet

AIX-FORMATBESKRIVARE
Denna ps stödjer AIX formatbeskrivare, vilka fungerar ungefär som formateringskoderna till printf(1) och printf(3). Till exempel kan den normala standardutmatningen skapas med detta: ps -eo "%p %y %x %c". De VANLIGA koderna beskrivs i nästa stycke.
KOD | VANLIG | RUBRIK
%C | pcpu | %CPU
%G | group | GRUPP
%P | ppid | FPID
%U | user | ANVÄNDARE
%a | args | KOMMANDO
%c | comm | KOMMANDO
%g | rgroup | VGRUPP
%n | nice | NI
%p | pid | PID
%r | pgid | PGID
%t | etime | FÖRFLUTEN
%u | ruser | VANV
%x | time | TID
%y | tty | TTY
%z | vsz | VST

STANDARDFORMATSPECIFICERARE
Här är de olika nyckelorden som kan användas för att styra utmatningsformatet (t.ex. med flaggan -o) eller för att sortera de valda processerna med GNU-stilsflaggan --sort.

Till exempel: ps -eo pid,user,args --sort user

Denna version av ps försöker känna igen de flesta nyckelord som används in andra implementationer av ps.

Följande användardefinierade formatspecificerare kan innehålla blanktecken: args, cmd, comm, command, fname, ucmd, ucomm, lstart, bsdstart, start.

Några nyckelord är kanske inte tillgängliga för sortering.
KOD | RUBRIK | BESKRIVNING
%cpu | %CPU | cpu-användning av processerna i formatet ”##.#”. För närvarande är det CPU-tiden som används dividerad med tiden som processen har kört (förhållandet cputid/verklig tid), uttryckt som en procentsats. Det kommer inte summeras till 100 % utom om du har tur. (alias pcpu).
%mem | %MIN | förhållandet mellan storleken på processens residenta mängd och det fysiska minnet på maskinen, uttryckt som en procentsats. (alias pmem).
ag_id | AGID | Autogruppidentifieraren som är associerad med en process som arbetar tillsammans med CFS-schemaläggaren för att förbättra interaktiv skrivbordsprestanda.
ag_nice | AGNI | Autogruppens nice-värde vilket påverkar schemaläggningen för alla processer e den gruppen.
args | KOMMANDO | kommandot med alla dess flaggor som en sträng. Ändringar av argumenten kan visas. Utdatan i denna kolumn kan innehålla blanktecken. En process markerad <defunct> är delvis död, och väntar på att helt destrueras av sin förälder. Ibland är processargumenten inte tillgängliga; när detta händer kommer ps istället skriva det körbara namnet i hakparenteser. (alias cmd, command). Se även formatnyckelordet comm flaggan -f och flaggan c. När den anges sist kommer denna kolumn sträcka sig till kanten av displayen. Om ps inte kan avgöra displaybredden, som när utdata är omdirigerad (pipe) till en fil eller ett annat kommando, är utdatabredden odefinierad (den kan vara 80, obegränsad, bestämd av variabeln TERM, och så vidare). Miljövariabeln COLUMNS eller flaggan --cols kan användas för att exakt bestämma bredden i detta fall. Flaggan w eller -w kan också användas för att justera bredden.
blocked | BLOCKED | mask av blockerade signaler, se signal(7). Enligt bredden på fältet visas en 32- eller 64-bitars mask i hexadecimalt format. (alias sig_block, sigmask).
bsdstart | START | tiden kommandot startade. Om processen startades för mindre än 24 timmar sedan, är utmatningsformatet ” HH:MM”, annars är den ” Mmm:SS” (där Mmm är de tre bokstäverna i månaden). Se även lstart, start, start_time och stime.
bsdtime | TID | accumulerad cpu-tid, användare + system. Visningsformatet är vanligen ”MMM:SS”, men kan justeras åt höger om processen har använt mer än 999 minuter cpu-tid.
c | C | processoranvändning. För närvarande är detta heltalsvärdet av procent användning över processens livslängd. (se %cpu).
caught | CAUGHT | mask av fångade signaler, se signal(7). Enligt bredden på fältet visas en 32- eller 64-bitars mask i hexadecimalt format. (alias sig_catch, sigcatch).
cgnamn | KGNAMN | visar namnet på kontrollgrupper vilka denna process hör till.
cgroup | KGRUPPR | visar kontrollgruppe vilka denna process hör till.
cgroupns | CGROUPNS | Unikt inodsnummer som beskriver namnrymden processen hör till. Se namespaces(7).
class | CLS | processens schemaläggningsklass. (alias policy, cls). Fältets möjliga värden är: - inte rapporterad TS SCHED_OTHER FF SCHED_FIFO RR SCHED_RR B SCHED_BATCH ISO SCHED_ISO IDL SCHED_IDLE DLN SCHED_DEADLINE ? okänt värde
cls | CLS | processens schemaläggningsklass. (alias policy, cls). Fältets möjliga värden är: - inte rapporterad TS SCHED_OTHER FF SCHED_FIFO RR SCHED_RR B SCHED_BATCH ISO SCHED_ISO IDL SCHED_IDLE DLN SCHED_DEADLINE ? okänt värde
cmd | CMD | se args. (alias args, command).
comm | KOMMANDO | kommandonamn (endast det körbara namnet). Utdata i denna kolumn kan innehålla blanktecken. (alias ucmd, ucomm). Se även formatnyckelordet args, flaggan -f och flaggan c. När den anges sist kommer denna kolumn sträcka sig till kanten av displayen. Om ps inte kan avgöra displaybredden, som när utdata är omdirigerad (pipe) till en fil eller ett annat kommando, är utdatabredden odefinierad (den kan vara 80, obegränsad, bestämd av variabeln TERM, och så vidare). Miljövariabeln COLUMNS eller flaggan --cols kan användas för att exakt bestämma bredden i detta fall. Flaggan w eller -w kan också användas för att justera bredden.
command | KOMMANDO | Se args. (alias args, command).
cp | CP | promille (tiondels procent) CPU-användning. (se %cpu).
cputime | TID | ackumulerad CPU-tid, formatet ”[DD-]hh:mm:ss”. (alias time).
cputimes | TID | ackumulerad CPU-tid i sekunder (alias times).
cuc | %CUB | En process CPU-användning, inklusive döda barn, i ett utökat format ”##.###”. (se även %cpu, c, cp, cuu, pcpu).
cuu | %CUA | En process CPU-användning i ett utökat format ”##.###”. (se även %cpu, c, cp, cuc, pcpu).
drs | DRS | storleken på den residenta mängden data, mängden fysiskt minne reserverat av en process. Det är även känt som DATA. Sådant minne behöver ännu inte vara mappat till rss men kommer alltid att inkluderas i mängden vsz.
egid | EGID | effektivt grupp-ID-nummer på processen som ett decimalt heltal. (alias gid).
egroup | EGROUP | effektivt grupp-ID på processen. Detta kommer vara det textuella grupp-ID:t om det kan hämtas och fältbredden tillåter, eller en decimal representation i annat fall. (alias group).
eip | EIP | instruktionspekaren. Från kärna 4.9.xx kommer det att vara nollställt utom om en uppgift avslutar eller dumpar minnet.
esp | ESP | stackpekaren. Från kärna 4.9.xx kommer det att vara nollställt utom om en uppgift avslutar eller dumpar minnet.
etime | FÖRFLUTEN | förlupen tid sedan processen startades, i formatet [[DD-]hh:]mm:ss.
etimes | FÖRFLUTEN | förlupen tid sedan processen startades, i sekunder.
euid | EUID | effektivt användar-ID (alias uid).
euser | EUSER | effektivt användarnamn. Detta kommer vara det textuella användar-ID:t, om det kan avgöras och fältbredden så tillåter, eller en decimal representation i annat fall. Flaggan n kan användas för att framtvinga den decimala representationen. (alias uname,\ user).
exe | EXE | sökvägen till den körbara. Användbart om sökvägen inte kan skrivas ut via formatflaggorna cmd, comm eller args.
f | F | flaggor associerade med processen, se avsnittet PROCESSFLAGGOR. (alias flag, flags).
fgid | FGID | filsystemsåtkomstgrupp-ID. (alias fsgid).
fgroup | FGROUP | filsystemets åtkomstgrupp-ID. Detta kommer vara det textuella grupp-ID:t om det kan hämtas och fältbredden tillåter, eller en decimal representation i annat fall. (alias fsgroup).
flag | F | se f. (alias f, flags).
flags | F | se f. (alias f, flag).
fname | KOMMANDO | de första 8 byten av basnamnet på processens körbara fil. Utmatningen i denna kolumn kan innehålla blanktecken.
fuid | FUID | filsystemsåtkomstanvändar-ID. (alias fsuid).
fuser | FUSER | filsystemsåtkomstanvändar-ID. Detta kommer vara det textuella användar-ID:t, om det kan hämtas och fältbredden tillåter, eller en decimal representation i annat fall.
gid | GID | se egid. (alias egid).
group | GRUPP | se egroup. (alias egroup).
ignored | IGNORED | mask över de ignorerade signalerna, se signal(7). Enligt fältets bredd visas en 32-bitars eller 64-bitars mask i hexadecimal form. (alias sig_ignore, sigignore).
ipcns | IPCNS | Unikt inodsnummer som beskriver namnrymden processen hör till. Se namespaces(7).
label | LABEL | säkerhetsetikett, vanligen använt för SELinux-kontextdata. Detta är till för tvingande åtkomstkontroll (”MAC”) som finns i högsäkerhetssystem.
lstart | STARTED | Tiden kommandot startade. Detta kommer vara i formatet ”DDD mmm HH:MM:SS ÅÅÅÅ” om det inte ändras av flaggan -D.
lsession | SESSION | visar identiferaren av inloggningssessionen för en process, om stöd för systemd har inkluderats.
luid | LUID | visar login-ID associerat med en process.
lwp | LWP | den körbara lättviktsprocessens (trådens) ID (alias spid, tid). Se tid för ytterligare information.
lxc | LXC | Namnet på lxc-behållaren i vilken en process kör. Om en process inte kör i en behållare kommer ett streck (”-”) visas.
machine | MACHINE | visar maskinnamnet för processer som tillhör en VM eller behållare, om stöd för systemd har inkluderats.
maj_flt | MAJFLT | Antalet större sidfel som har inträffat för denna process.
min_flt | MINFLT | Antalet mindre sidfel som har inträffat för denna process.
mntns | MNTNS | Unikt inodsnummer som beskriver namnrymden processen hör till. Se namespaces(7).
netns | NETNS | Unikt inodsnummer som beskriver namnrymden processen hör till. Se namespaces(7).
ni | NI | nice-värde. Detta går från 19 (trevligast) till -20 (inte trevligt mot andra), se nice(1). (alias nice).
nice | NI | se ni. (alias ni).
nlwp | NLWP | antal lwps (trådar) i processen. (alias thcount).
numa | NUMA | Noden associerad med den senast använda processorn. Ett -1 betyder att NUMA-information inte är tillgänglig.
nwchan | VKAN | adress till kärnfunktionen där processen sover (använd wchan om du vill veta kärnfunktionens namn).
oom | OOM | Slut-på-minne-värde. Värdet, från 0 till +1000, som används för att välja uppgift(er) att döda när minnet tar slut.
oomadj | OOMADJ | Slut-på-minne-justeringsfaktor. Värdet läggs till till det aktuella slut-på minnet-värdet som sedan används för att avgöra vilken uppgift som skall dödas när minnet tar slut.
ouid | OWNER | visar Unix-användaridentifieraren för ägaren av processens sessionen, om stöd för systemd har inkluderats.
pcpu | %CPU | se %cpu. (alias %cpu).
pending | PENDING | mask av väntande signaler. Se signal(7). Signaler som väntar på processen skiljer sig från signaler som väntar på enskilda trådar. Använd flaggan m eller flaggan -m för att se båda. Enligt fältets bredd visas en 32- eller 64-bitars mask i hexadecimal form. (alias sig).
pgid | PGID | processgrupps-ID eller, likvärdigt, process-ID:t på processgruppledaren. (alias pgrp).
pgrp | PGRP | se pgid. (alias pgid).
pid | PID | ett nummer representerade process-ID:t (alias tgid).
pidns | PIDNS | Unikt inodsnummer som beskriver namnrymden processen hör till. Se namespaces(7).
pmem | %MIN | se %mem. (alias %mem).
policy | POL | processens schemaläggningsklass. (alias class, cls). Möjliga värden är: - inte rapporterad TS SCHED_OTHER FF SCHED_FIFO RR SCHED_RR B SCHED_BATCH ISO SCHED_ISO IDL SCHED_IDLE DLN SCHED_DEADLINE ? okänt värde
ppid | FPID | föräldraprocess-ID.
pri | PRI | processens prioritet. Högre tal betyder högre prioritet.
psr | PSR | processor som processen senast körde på.
pss | ARSS | Proportinell andels storlek, det inte utväxlade fysiska minnet, med delat minne proportionellt fördelat över alla uppgifter som avbildar in det.
rbytes | RBYTES | Antal byte som denna process verkligen fick att hämtas från lagringslagret.
rchars | RCHARS | Antal byte som denna uppgift har orsakat att de lästs in från lagringen.
rgid | VGID | verkligt grupp-ID.
rgroup | VGRUPP | verkligt gruppnamn. Detta kommer vara det textuella grupp-ID:t, om det kan hämtas och fältbredden tillåter, eller en decimal representation i annat fall.
rops | ROPS | Antal läsnings-I/O-åtgärder — det vill säga, systemanrop såsom read(2) och pread(2).
rss | RSS | residenta mängdens storlek, det ej utväxlade fysiska minnet som en uppgift har använt (i kiloyte). (alias rssize, rsz).
rssize | RSS | se rss. (alias rss, rsz).
rsz | RSZ | se rss. (alias rss, rssize).
rtprio | RTPRIO | realtidsprioritet.
ruid | VAID | verkligt användar-ID.
ruser | VANV | verkligt användar-ID. Detta kommer vara det textuella användar-ID:t, om det kan hämtas och fältbredden tillåter, eller en decimal representation i annat fall.
s | S | minimal tillståndsvisning (en bokstav). Se avsnittet PROCESSTATUSKODER för de olika värdena. Se även stat om du vill ha ytterligare information visad. (alias state).
sched | SCH | schemaläggninspolicy för processen. Policyerna SCHED_OTHER (SCHED_NORMAL), SCHED_FIFO, SCHED_RR, SCHED_BATCH, SCHED_ISO, SCHED_IDLE och SCHED_DEADLINE visas som 0, 1, 2, 3, 4, 5 respektive 6.
seat | SEAT | visar identifieraren associerad med alla hårdvaruenheter tilldelade till en specifik arebetsplats, om stöd för systemd har inkluderats.
sess | SESS | sessions-ID eller, likvärdigt, process-ID för sessionsledaren. (alias session, sid).
sgi_p | P | processor som processen för närvarande kör på. Visar ”*” om processen inte kör eller är körbar just nu.
sgid | SGID | sparat grupp-ID. (alias svgid).
sgroup | SGROUP | sparat gruppnamn. Detta kommer vara det textuella grupp-ID:t, om det kan hämtas och fältbredden tillåter, eller en decimal representation i annat fall.
sid | SID | se sess. (alias sess, session).
sig | PENDING | se pending. (alias pending, sig_pend).
sigcatch | CAUGHT | se caught. (alias caught, sig_catch).
sigignore | IGNORED | se ignored. (alias ignored, sig_ignore).
sigmask | BLOCKED | se blocked. (alias blocked, sig_block).
size | SIZE | ungefärlig mängd växlingsutrymme som skulle krävas om processen skulle smutsa ner alla skrivbara sidor och sedan växlas ut. Denna beräkning är väldigt grov!
slice | SLICE | visar skivenheten vilken en process hör till, om stöd för systemd har inkluderats.
spid | SPID | se lwp. (alias lwp, tid).
stackp | STACKP | adressen till botten (början) av processens stack.
start | STARTED | tiden kommandot startade. Om processen startades för mindre än 24 timmar sedan är utdataformatet ”HH:MM:SS”, annars är det ” Mmm dd” (där Mmm är ett trebokstavs månadsnamn). Se även lstart, bsdstart, start_time, och stime.
start_time | START | processens starttid eller -datum. Endast året kommer visas om processen inte startades samma år ps kördes, eller ”MmmDD” om den inte startades samma dag, eller ”HH:MM” annars. Se även bsdstart, start, lstart, och stime.
stat | STAT | flerteckens processtillstånd. Se avsnittet PROCESSTATUSKODER för de olika värdenas betydelse. Se även s och state om du bara vill visa den första bokstaven.
state | S | se s. (alias s).
stime | STID | se start_time. (alias start_time).
suid | SAID | sparat användar-ID. (alias svuid).
supgid | SUPGID | grupp-id:n av kompletterande grupper, om det finns några. Se getgroups(2).
supgrp | SUPGRP | gruppnamn på kompletterande grupper, om det finns några. Se getgroups(2).
suser | SANV | sparat användarnamn. Detta kommer vara det textuella användar-ID:t, om det kan hämtas och fältbredden tillåter, eller en decimal representation i annat fall.
svgid | SVGID | se sgid. (alias sgid).
svuid | SVUID | se suid. (alias suid).
sz | SZ | storlek i fysiska sidor på processens kärnavbild. Detta inkluderar text-, data- och stackutrymme. Enhetsinmappningar exkluderas för närvarande, detta kan komma att ändras. Se vsz och rss.
tgid | TGID | ett tal som representerar trådgruppen som uppgiften tillhör (alias pid). Det är process-ID:t på trådgruppledaren.
thcount | THCNT | se nlwp. (alias nlwp). antal kärntrådar som processen äger.
tid | TID | Det unika numret som representerar en körbar enhet (alias lwp, spid). Detta värde kan även förekomma som: ett process-ID (pid); ett processgrupp-ID (pgrp); ett sessions-ID för en sessionsledare (sid); ett trådgrupps-ID för trådgrubbsledaren (tgid); och ett tty-processgrupps-ID för processgruppsledaren (tpgid).
time | TID | ackumulerad CPU-tid, formatet ”[DD-]HH:MM:SS”. (alias cputime).
timens | TIDNR | Unikt inodsnummer som beskriver namnrymden processen hör till. Se namespaces(7).
times | TID | ackumulerad CPU-tid i sekunder (alias cputimes).
tname | TTY | styr-tty (terminal). (alias tt, tty).
tpgid | TPGID | Förgrundsprocessgruppens ID på tty:n (terminalen) som processen är kopplad till, eller -1 om processen inte är kopplad till någon tty.
trs | TRS | den residenta text-mängdens storlek, mängden fysiskt minne tilldelat till körbar kod.
tt | TT | styr-tty (terminal). (alias tname, tty).
tty | TT | styr-tty (terminal). (alias tname, tt).
ucmd | CMD | se comm. (alias comm, ucomm).
ucomm | KOMMANDO | se comm. (alias comm, ucmd).
uid | AID | se euid. (alias euid).
uname | ANVÄNDARE | se euser. (alias euser, user).
unit | UNIT | visar enheten vilken en process hör till, om stöd för systemd har inkluderats.
user | ANVÄNDARE | se euser. (alias euser, uname).
userns | USERNS | Unikt inodsnummer som beskriver namnrymden processen hör till. Se namespaces(7).
uss | URSS | Unika mängdens storlek, det inte utväxlade fysiska minnet, vilket inte delas med en annan uppgift.
utsns | UTSNS | Unikt inodsnummer som beskriver namnrymden processen hör till. Se namespaces(7).
uunit | UUNIT | visar användarenheten vilken en process hör till, om stöd för systemd har inkluderats.
vsize | VST | se vsz. (alias vsz).
vsz | VST | storleken på processens virtuella minne i KiB (1024-bytenheter). Enhetsinmappningar exkluderas för närvarande, detta kan komma att ändras. (alias vsize).
wbytes | WBYTES | Antal byte vilka denna process fick att skickas till lagringslagret.
wcbytes | WCBYTES | Antal inställda skrivbyte.
wchan | VKAN | namnet på kärnfunktionen i vilken processen sover.
wchars | WCHARS | Antal byt vilka denna uppgift har fått, eller kommer att få skrivas till disk.
wops | WOPS | Antal skrivnings-I/O-åtgärder — det vill säga, systemanrop såsom write(2) och pwrite(2).

MILJÖVARIABLER
Följande miljövariabler kan påverka ps:

COLUMNS
    Åsidosätt standardvisningsbredden.

LINES
    Åsidosätt standardvisningshöjden.

PS_PERSONALITY
    Sätt till en av posix, old, linux, bsd, sun, digital … (se avsnittet PERSONLIGHET nedan).

CMD_ENV
    Sätt till en av posix, old, linux, bsd, sun, digital … (se avsnittet PERSONLIGHET nedan).

I_WANT_A_BROKEN_PS
    Framtvinga fåråldrad tolkning av kommandoraden.

LC_TIME
    Datumformat.

LIBPROC_HIDE_KERNEL
    Sätt detta till vilket värde so helst för att dölja kärntrådar som normalt visas med flaggan -e. Detta är likvärdigt med att välja --ppid 2 -p 2 --deselect istället. Fungerar även i BSD-läge.

PS_COLORS
    Stödjs inte för närvarande.

PS_FORMAT
    Åsidosättande av standardutmatningsformat. Man kan sätta detta till en formatsträng av typen som används till flaggan -o. Värdena DevSysV och DefBSD är särskilt användbara.

POSIXLY_CORRECT
    Sök inte ursäkter för att ignorera dåliga ”funktioner”.

POSIX2
    När satt till ”on”, fungerar som POSIXLY_CORRECT.

UNIX95
    Sök inte ursäkter för att ignorera dåliga ”funktioner”.

_XPG
    Annulera icke-standardbettendet hos CMD_ENV=irix.

I allmänhet är det en dålig idé att sätta dessa variabler. Enda undantaget är CMD_ENV eller PS_PERSONALITY, vilket kan sättas till Linux för normala system. Utan den inställningen följer ps de oanvändbara och dåliga delarna av standarden Unix98.

PERSONLIGHET
390 | som ps på OS/390 Open Edition
aix | som ps på AIX
bsd | som ps på FreeBSD (helt ostandardiserat)
compaq | som ps på Digital Unix
debian | som den gamla ps på Debian
digital | som ps på Tru64 (före detta Digital Unix, före detta OSF/1)
gnu | som den gamla ps på Debian
hp | som ps på HP-UX
hpux | som ps på HP-UX
irix | som ps på Irix
linux | ***** rekommenderas *****
old | som den ursprungliga ps på Linux (helt ostandardiserat)
os390 | som ps på OS/390 Open Edition
posix | standard
s390 | som ps på OS/390 Open Edition
sco | som ps på SCO
sgi | som ps på Irix
solaris2 | som ps på Solaris 2+ (SunOS 5)
sunos4 | som ps på SunOS 4 (Solaris 1) (helt ostandardiserat)
svr4 | standard
sysv | standard
tru64 | som ps på Tru64 (före detta Digital Unix, före detta OSF/1)
unix | standard
unix95 | standard
unix98 | standard

FEL
Fälten bsdstart och start kommer endast visa det förkortade månadsnamnet på engelska. Fältet lstart och stime kommer visa det förkortade månadsnamnet i den konfigurerade lokalen men kan överskrida kolumnbredden på grund av olika längder för förkortade månads- och dagnamn mellan språk.

SE ÄVEN
pgrep(1), pstree(1), top(1), strftime(3), proc(5).

STANDARDER
Denna ps följer:

1   Version 2 av Single Unix Specification
2   Technical Standard Base Specifications, utgåva 6 från Open Group
3   IEEE Std 1003.1, utgåva 2004
4   X/Open System Interfaces Extension [UP XSI]
5   ISO/IEC 9945:2003

UPPHOVSMAN
ps skrevs ursprungligen av Branko Lankester (lankeste@fwi.uva.nl) Michael K. Johnson (johnsonm@redhat.com) skrev om det signifikant till att använda proc-filsystemet och ändrade en del saker på vägen. Michael Shields (mjshield@nyx.cs.du.edu) lade till funktionen pid-lista. Charles Blake (cblake@bbn.com) lade till flernivåsortering, bibliotek i dirent-stil, databasen med avbildningar från namn till nummer, den ungefärliga binära sökningen direkt i System.map och gjorde många kod- och dokumentationsstädningar. David Mossberger-Tang skrev det generiska stödet av BFD för psupdate. Albert Cahalan (albert@users.sf.net) skrev om ps med fullständigt stöd för Unix98 och BSD, tillsammans med några fula hack för föråldrad och främmande syntax.

Skicka felrapporter till procps@freelists.org. Ingen prenumeration krävs eller föreslås. Skicka synpunkter på översättningen till tp-sv@listor.tp-sv.se